﻿Partial Public Class AllNavigationEvents
    Inherits PhoneApplicationPage
    Public Sub New()
        InitializeComponent()
        AddHandler Loaded, AddressOf AllNavigationEvents_Loaded
        Me.instanceId = nextId
        nextId += 1
    End Sub

    Private Sub AllNavigationEvents_Loaded(ByVal sender As Object, ByVal e As RoutedEventArgs)
        Debug.WriteLine("Loaded " & instanceId)

        PageTitle.Text = "Instance " & instanceId

        backButton.IsEnabled = NavigationService.CanGoBack
        forwardButton.IsEnabled = NavigationService.CanGoForward

    End Sub

    Private Sub AllNavigationEvents_Unloaded(ByVal sender As Object, ByVal e As RoutedEventArgs)
    End Sub

    Private Sub AllNavigationEvents_NavigationStopped(ByVal sender As Object,
                                                      ByVal e As System.Windows.Navigation.NavigationEventArgs)
        Debug.WriteLine("PhoneApplicationFrame.NavigationStopped " & e.Uri.ToString)
    End Sub

    Private Sub AllNavigationEvents_Navigated(ByVal sender As Object,
                                              ByVal e As System.Windows.Navigation.NavigationEventArgs)
        Debug.WriteLine("PhoneApplicationFrame.Navigated to " & e.Uri.ToString)
    End Sub

    Private Sub AllNavigationEvents_Navigating(ByVal sender As Object,
                                               ByVal e As System.Windows.Navigation.NavigatingCancelEventArgs)
        Debug.WriteLine("PhoneApplicationFrame.Navigating to " & e.Uri.ToString)
    End Sub

    Protected Overrides Sub OnNavigatedFrom(ByVal e As System.Windows.Navigation.NavigationEventArgs)
        MyBase.OnNavigatedFrom(e)
        Debug.WriteLine("PhoneApplicationPage.OnNavigatedFrom " & instanceId)


    End Sub

    Protected Overrides Sub OnNavigatedTo(ByVal e As System.Windows.Navigation.NavigationEventArgs)
        MyBase.OnNavigatedTo(e)
        Debug.WriteLine("PhoneApplicationPage.OnNavigatedTo " & instanceId)

        'the first time this is loaded, we start listening
        If instanceId = 0 AndAlso nextId = 1 Then
            'NOTE: This leads to a memory leak.  We should 
            AddHandler (CType(App.Current.RootVisual, PhoneApplicationFrame)).Navigating, AddressOf AllNavigationEvents_Navigating
            AddHandler (CType(App.Current.RootVisual, PhoneApplicationFrame)).Navigated, AddressOf AllNavigationEvents_Navigated
            AddHandler (CType(App.Current.RootVisual, PhoneApplicationFrame)).NavigationStopped, AddressOf AllNavigationEvents_NavigationStopped

        End If
    End Sub

    Protected Overrides Sub OnNavigatingFrom(ByVal e As System.Windows.Navigation.NavigatingCancelEventArgs)
        MyBase.OnNavigatingFrom(e)
        Debug.WriteLine("PhoneApplicationPage.OnNavigatingFrom " & instanceId)

        If e.NavigationMode = System.Windows.Navigation.NavigationMode.Back AndAlso Me.instanceId = 0 Then
            System.Diagnostics.Debug.WriteLine("Stopped listening to nav events")
            RemoveHandler (CType(App.Current.RootVisual, PhoneApplicationFrame)).Navigating, AddressOf AllNavigationEvents_Navigating
            RemoveHandler (CType(App.Current.RootVisual, PhoneApplicationFrame)).Navigated, AddressOf AllNavigationEvents_Navigated
            RemoveHandler (CType(App.Current.RootVisual, PhoneApplicationFrame)).NavigationStopped, AddressOf AllNavigationEvents_NavigationStopped
        End If
    End Sub

    Private Sub OnBack(ByVal unused As Object, ByVal unused2 As RoutedEventArgs)
        If NavigationService.CanGoBack Then NavigationService.GoBack()

    End Sub

    Private Sub OnForward(ByVal unused As Object, ByVal unused2 As RoutedEventArgs)
        If NavigationService.CanGoForward Then NavigationService.GoForward()

    End Sub

    Private Shared nextId As Integer
    Private instanceId As Integer

    Private Sub OnNavigateNext(ByVal unused As Object, ByVal unused2 As RoutedEventArgs)
        Dim [next] = String.Format("/AllNavigationEvents.xaml?nextId={0}", nextId)
        Dim uri As New Uri([next], UriKind.Relative)
        Me.NavigationService.Navigate(uri)

    End Sub
End Class