﻿Partial Public Class LevelPage
    Inherits PhoneApplicationPage

    Private navigationCompletedListener As WeakEventListener(Of LevelPage, Object, HomeNavigationCompletedEventArgs)
    Private navigationStartedListener As WeakEventListener(Of LevelPage, Object, HomeNavigationStartedEventArgs)

    Public Sub New()
        InitializeComponent()

        'AddHandler BackNavigationHelper.Instance.BackNavigationStarted, AddressOf new EventHandler<BackNavigationStartedEventArgs>(Instance_BackNavigationStarted);
        'AddHandler BackNavigationHelper.Instance.BackNavigationCompleted, AddHandler new EventHandler<BackNavigationCompletedEventArgs>(Instance_BackNavigationCompleted);

        navigationCompletedListener = New WeakEventListener(Of LevelPage, Object, HomeNavigationCompletedEventArgs)(Me)
        navigationCompletedListener.OnEventAction =
            Sub(instance, source, args) instance.Instance_BackNavigationCompleted(source, args)
        navigationCompletedListener.OnDetachAction =
            Sub(listener)
                RemoveHandler HomeNavigationHelper.Instance.HomeNavigationCompleted, AddressOf listener.OnEvent
            End Sub

        AddHandler HomeNavigationHelper.Instance.HomeNavigationCompleted, AddressOf navigationCompletedListener.OnEvent


        navigationStartedListener = New WeakEventListener(Of LevelPage, Object, HomeNavigationStartedEventArgs)(Me)
        navigationStartedListener.OnEventAction =
            Sub(instance, source, args) instance.Instance_BackNavigationStarted(source, args)
        navigationStartedListener.OnDetachAction =
            Sub(listener)
                RemoveHandler HomeNavigationHelper.Instance.HomeNavigationStarting, AddressOf listener.OnEvent
            End Sub

        AddHandler HomeNavigationHelper.Instance.HomeNavigationStarting, AddressOf navigationStartedListener.OnEvent



#If DEBUG Then
        instanceCount += 1
#End If
    End Sub

#If DEBUG Then
    Private Shared instanceCount As Integer
    Protected Overrides Sub Finalize()
        System.Diagnostics.Debug.WriteLine("~Level: {0} instances left", instanceCount)
        instanceCount -= 1
    End Sub

#End If


    Private appBarVisibility As Boolean
    Private Sub Instance_BackNavigationCompleted(ByVal sender As Object, ByVal e As HomeNavigationCompletedEventArgs)
        If HomeNavigationHelper.DemoSettings.HideAppBarOnNavigate Then Me.ApplicationBar.IsVisible = appBarVisibility
    End Sub

    Private Sub Instance_BackNavigationStarted(ByVal sender As Object, ByVal e As HomeNavigationStartedEventArgs)
        If HomeNavigationHelper.DemoSettings.HideAppBarOnNavigate Then
            appBarVisibility = Me.ApplicationBar.IsVisible
            Me.ApplicationBar.IsVisible = False
        End If
    End Sub

    Public Shared [Next] As Integer
    Public instanceId As Integer
    Private level As Integer = 0
    Private item As Integer = 0
    Protected Overrides Sub OnNavigatedTo(ByVal e As System.Windows.Navigation.NavigationEventArgs)
        If Not HomeNavigationHelper.Instance.IsDoingHomeNavigation Then
            MyBase.OnNavigatedTo(e)
            If NavigationContext.QueryString.ContainsKey("level") Then level = Integer.Parse(NavigationContext.QueryString("level"))
            If NavigationContext.QueryString.ContainsKey("item") Then item = Integer.Parse(NavigationContext.QueryString("item"))

            Dim appbarstring As String = Nothing
            If NavigationContext.QueryString.TryGetValue("appbar", appbarstring) Then
                Dim showAppbarFlag As Boolean
                Boolean.TryParse(appbarstring, showAppbarFlag)
                Me.ApplicationBar.IsVisible = showAppbarFlag
                Me.showAppBar.IsChecked = showAppbarFlag
            End If

            Me.PageTitle.Text = "level " & level

            If level > 0 Then upLevel.IsEnabled = True
        Else
            If Me.ApplicationBar.IsVisible Then
                System.Diagnostics.Debug.WriteLine("Hiding appbar in tombstone back")
                appBarVisibility = Me.ApplicationBar.IsVisible
                Me.ApplicationBar.IsVisible = HomeNavigationHelper.DemoSettings.HideAppBarOnNavigate
            End If
        End If
    End Sub


    Private Sub GoHome(ByVal sender As Object, ByVal args As RoutedEventArgs)
        HomeNavigationHelper.Instance.StartHomeNavigation(New Uri("/HomeNavigationSamplePages/LevelPage.xaml?level=0", UriKind.Relative))
    End Sub

    Private Sub GoUp(ByVal sender As Object, ByVal args As RoutedEventArgs)
        Dim targetUri As New Uri(String.Format("/HomeNavigationSamplePages/LevelPage.xaml?level={0}&appbar={1}", level - 1, showAppBar.IsChecked.Value), UriKind.Relative)

        HomeNavigationHelper.Instance.SafeNavigate(targetUri)
    End Sub

    Private Sub GoDown(ByVal u As Object, ByVal u2 As RoutedEventArgs)
        Dim targetUri As New Uri(String.Format("/HomeNavigationSamplePages/LevelPage.xaml?level={0}&appbar={1}", level + 1, showAppBar.IsChecked.Value), UriKind.Relative)


        HomeNavigationHelper.Instance.SafeNavigate(targetUri)
    End Sub

    Private Sub GoBack(ByVal u As Object, ByVal u2 As RoutedEventArgs)
        If NavigationService.CanGoBack Then NavigationService.GoBack()
    End Sub

    Private Sub GoToItem(ByVal u As Object, ByVal u2 As RoutedEventArgs)
        Dim targetUri As New Uri(String.Format("/HomeNavigationSamplePages/ItemPage.xaml?level={0}&item={1}&appbar={2}", level, item + 1, showAppBar.IsChecked.Value), UriKind.Relative)
        HomeNavigationHelper.Instance.SafeNavigate(targetUri)
    End Sub
End Class