﻿Partial Public Class App
    Inherits Application
    ''' <summary>
    ''' Provides easy access to the root frame of the Phone Application.
    ''' <returns>The root frame of the Phone Application.</returns>
    ''' </summary>
    Private _RootFrame As PhoneApplicationFrame
    Public Property RootFrame As PhoneApplicationFrame
        Get
            Return _RootFrame
        End Get
        Private Set(ByVal value As PhoneApplicationFrame)
            _RootFrame = value
        End Set
    End Property

    ''' <summary>
    ''' Constructor for the Application object.
    ''' </summary>
    Public Sub New()
        'Global handler for uncaught exceptions. 
        AddHandler UnhandledException, AddressOf Application_UnhandledException

        'Show graphics profiling information while debugging.
        If System.Diagnostics.Debugger.IsAttached Then Application.Current.Host.Settings.EnableFrameRateCounter = True

        'Standard Silverlight initialization
        InitializeComponent()

        'Phone-specific initialization
        InitializePhoneApplication()
    End Sub

    'Code to execute when the application is launching (eg, from Start)
    'This code will not execute when the application is reactivated
    Private Sub Application_Launching(ByVal sender As Object, ByVal e As LaunchingEventArgs)
    End Sub

    'Code to execute when the application is activated (brought to foreground)
    'This code will not execute when the application is first launched
    Private Sub Application_Activated(ByVal sender As Object, ByVal e As ActivatedEventArgs)
    End Sub

    'Code to execute when the application is deactivated (sent to background)
    'This code will not execute when the application is closing
    Private Sub Application_Deactivated(ByVal sender As Object, ByVal e As DeactivatedEventArgs)
    End Sub

    'Code to execute when the application is closing (eg, user hit Back)
    'This code will not execute when the application is deactivated
    Private Sub Application_Closing(ByVal sender As Object, ByVal e As ClosingEventArgs)
    End Sub

    'Code to execute if a navigation fails
    Private Sub RootFrame_NavigationFailed(ByVal sender As Object, ByVal e As NavigationFailedEventArgs)
        If System.Diagnostics.Debugger.IsAttached Then System.Diagnostics.Debugger.Break()
    End Sub

    'Code to execute on Unhandled Exceptions
    Private Sub Application_UnhandledException(ByVal sender As Object, ByVal e As ApplicationUnhandledExceptionEventArgs)
        If System.Diagnostics.Debugger.IsAttached Then System.Diagnostics.Debugger.Break()
    End Sub

#Region "Phone application initialization"

    'Avoid double-initialization
    Private phoneApplicationInitialized As Boolean = False

    'Do not add any additional code to this method
    Private Sub InitializePhoneApplication()
        If phoneApplicationInitialized Then Return


        'TRANSITION STEP 1:  Replace the PhoneApplicationFrame with a TransitionFrame 
        RootFrame = New Microsoft.Phone.Controls.TransitionFrame
        AddHandler RootFrame.Navigated, AddressOf CompleteInitializePhoneApplication

        'Handle navigation failures
        AddHandler RootFrame.NavigationFailed, AddressOf RootFrame_NavigationFailed

        'Ensure we don't initialize again
        phoneApplicationInitialized = True
    End Sub

    'Do not add any additional code to this method
    Private Sub CompleteInitializePhoneApplication(ByVal sender As Object, ByVal e As NavigationEventArgs)
        'Set the root visual to allow the application to render
        If RootVisual IsNot RootFrame Then RootVisual = RootFrame

        'Remove this handler since it is no longer needed
        RemoveHandler RootFrame.Navigated, AddressOf CompleteInitializePhoneApplication
    End Sub

#End Region
End Class